import { All, FType2type } from "./FieldTypes";
import { StoreType, ControllerConfig, Errors as Errs } from "./types";
import { ValueStorage } from "./Models/ValueStorage";
import { Errors } from "./Models/Errors";
import { AdvancedObservable } from "./Models/AdvancedObservable";
export declare class FormController<FieldsTypes extends {
    [key: string]: All;
}, SubmitArgs extends any[]> {
    private config;
    private values;
    private guards;
    private validators;
    private pending;
    private pendingObservable;
    private submitObservable;
    errors: Errors<FieldsTypes>;
    constructor(config: ControllerConfig<FieldsTypes, SubmitArgs>);
    set<K extends keyof FieldsTypes>(name: K, value: FType2type<FieldsTypes[K]>): void;
    get<K extends keyof FieldsTypes>(name: K): FType2type<FieldsTypes[K]> | undefined;
    isPending(): boolean;
    clear(): void;
    change(name: string, nextValue: any): void;
    getValues(): Partial<StoreType<FieldsTypes>>;
    submit(...arg: SubmitArgs): void | Errs<FieldsTypes>;
    subscribe(type: "errors", cb: Parameters<Errors<FieldsTypes>["subscribe"]>[0]): ReturnType<Errors<FieldsTypes>["subscribe"]>;
    subscribe(type: "submit", cb: Parameters<AdvancedObservable<StoreType<FieldsTypes>>['subscribe']>[0]): ReturnType<AdvancedObservable<StoreType<FieldsTypes>>['subscribe']>;
    subscribe(type: "values", cb: Parameters<ValueStorage<FieldsTypes>["subscribe"]>[0]): ReturnType<ValueStorage<FieldsTypes>["subscribe"]>;
    subscribe(type: "pending", cb: Parameters<AdvancedObservable<{
        pending: boolean;
    }>["subscribe"]>[0]): ReturnType<AdvancedObservable<{
        pending: boolean;
    }>["subscribe"]>;
}
